<template>
  <b-tabs content-class="mt-3">
    <b-tab v-if="resourceTypeOptionsLength > 1" :title="$t('tabSetup')">
      <setup :resource="resource" :isOwner="isOwner" :isLoading="isLoading" />
    </b-tab>
    <b-tab :title="$t('tabGeneralInfo')">
      <general-info
        :resource="resource"
        :isOwner="isOwner"
        :isLoading="isLoading"
        :displayNameIsLocked="displayNameIsLocked"
        :licenses="licenses"
        :disciplines="disciplines"
        :visibilities="visibilities"
        :keywordoptions="keywordoptions"
        :disciplineLabel="disciplineLabel"
        @translateResourceNameToDisplayName="translateResourceNameToDisplayName"
        @addTag="addTag"
        @lockDisplayName="lockDisplayName"
      />
    </b-tab>
    <b-tab :title="$t('tabMetadata')">
      <Metadata
        :resource="resource"
        :isOwner="isOwner"
        :isLoading="isLoading"
        :applicationProfile="applicationProfile"
      />
    </b-tab>
    <b-tab title="Actions">
      <actions
        :resource="resource"
        :resourceId="resourceId"
        :isOwner="isOwner"
        :isLoading="isLoading"
        :isWaitingForResponse="isWaitingForResponse"
        @deleteResource="deleteResource"
      />
    </b-tab>
  </b-tabs>
</template>

<script lang="ts">
import Vue from "vue";

import GeneralInfo from "./tabs/GeneralInfo.vue";
import Metadata from "./tabs/Metadata.vue";
import Setup from "./tabs/Setup.vue";
import Actions from "./tabs/Actions.vue";

export default Vue.extend({
  name: "TabView",
  components: {
    GeneralInfo,
    Metadata,
    Setup,
    Actions,
  },
  data() {
    return {};
  },
  props: {
    resource: Object,
    isOwner: {
      default: false,
      type: Boolean,
    },
    resourceId: String,
    applicationProfile: Array,
    displayNameIsLocked: Boolean,
    licenses: Array,
    disciplines: Array,
    visibilities: Array,
    keywordoptions: Array,
    disciplineLabel: String,
    resourceTypeOptionsLength: Number,
    isLoading: {
      default: false,
      type: Boolean,
    },
    isWaitingForResponse: {
      default: false,
      type: Boolean,
    },
  },
  methods: {
    deleteResource() {
      this.$emit("deleteResource");
    },
    translateResourceNameToDisplayName() {
      this.$emit("translateResourceNameToDisplayName");
    },
    addTag(val: any) {
      this.$emit("addTag", val);
    },
    lockDisplayName() {
      this.$emit("lockDisplayName");
    },
  },
});
</script>

<style></style>
